import { Component, OnInit, ViewChild, ElementRef } from '@angular/core';

@Component({
  selector: 'app-capture',
  templateUrl: './capture.component.html',
  styleUrls: ['./capture.component.scss']
})
export class CaptureComponent implements OnInit {

  constructor() {
    this.captures = [];
  }
  get video(): HTMLVideoElement {
    return this.videoRef.nativeElement;
  }
  get canvas(): HTMLCanvasElement {
    return this.canvasRef.nativeElement;
  }
  get mainVideoBody(): HTMLCanvasElement {
    return this.mainVideoBodyRef.nativeElement;
  }

  captures: Array<any>;

  @ViewChild('video') videoRef: ElementRef;

  @ViewChild('canvas') canvasRef: ElementRef;

  @ViewChild('mainVideoBody') mainVideoBodyRef: ElementRef;

  ngOnInit() { }

  // TODO: May want to check why this was throwing a lint error
  // tslint:disable-next-line: use-life-cycle-interface
  async ngAfterViewInit() {
    if (navigator.mediaDevices && navigator.mediaDevices.getUserMedia) {
      // const stream = await navigator.mediaDevices.getUserMedia({ video: true })
      // this.video.srcObject = stream;
    }
  }

  capture() {
    const context = this.canvas.getContext('2d').drawImage(this.mainVideoBody, 0, 0, 640, 480);
    this.captures.push(this.canvas.toDataURL('image/png'));
  }
}
