import { Component, OnInit, ViewChild, OnChanges } from '@angular/core';
import { ModalController, IonIcon } from '@ionic/angular';
import { ElementRef } from '@angular/core';
import { componentHostSyntheticProperty } from '@angular/core/src/render3';
import { EmailComposer } from '@ionic-native/email-composer/ngx';
import { StateService } from 'src/app/services/state.service';

@Component({
  selector: 'app-loading-content',
  templateUrl: './loading-content.component.html',
  styleUrls: ['./loading-content.component.scss'],
})
export class LoadingContentComponent implements OnInit {
  @ViewChild('icon') icon: IonIcon;
  public icons = [{ img: 'assets/icon/cloud_download-24px.svg' },
                  { img: 'assets/icon/lock_open-24px.svg' },
                  { img: 'assets/icon/TW-Icon_Blue_RGB-01.svg'}];
  public counter = 0.33;

  constructor(
    private modalCtrl: ModalController,
    private emailComposer: EmailComposer,
    private stateService: StateService
    ) {}

  ngOnInit() {
  }

  close() {
    this.modalCtrl.dismiss();
  }

  public async customerSupportClicked() {
    const email = {
      to: 'support@theraweconnect.com',
      cc: '',
      bcc: [],
      attachments: [],
      subject: '',
      body: '',
      isHtml: true
    };

    if (this.stateService.getPlatform() === 'web') {
      window.open(`mailto:${email.to}?subject=${email.subject}&body=${email.body}`);
    } else {
      this.emailComposer.open(email);
    }
  }

}
