import { Component, OnInit, Input } from '@angular/core';
import { ModalController } from '@ionic/angular';
import { SessionService } from '../../../services/session.service';

@Component({
  selector: 'app-session-draft',
  templateUrl: './session-draft.component.html',
  styleUrls: ['./session-draft.component.scss'],
})
export class SessionDraftComponent implements OnInit {
  @Input() sessionId: string;
  public date = new Date();
  constructor(
    private modalCtrl: ModalController,
    private sessionService: SessionService
  ) { }

  ngOnInit() {}

  close() {
    this.modalCtrl.dismiss();
  }

  yes() {
    this.sessionService.deleteSession(this.sessionId).subscribe();
    this.modalCtrl.dismiss({
      allow: true
    });
  }

  no() {
    this.modalCtrl.dismiss({
      allow: false
    });
  }

}
