import { Component, OnInit, Input } from '@angular/core';
import { ModalController } from '@ionic/angular';
import { SessionService } from '../../../services/session.service';
import { StateService } from 'src/app/services/state.service';

@Component({
  selector: 'app-session-view-attachment',
  templateUrl: './session-view-attachment.component.html',
  styleUrls: ['./session-view-attachment.component.scss'],
})
export class SessionViewAttachmentComponent implements OnInit {
  @Input() link;
  public size = 50;
  public disablePlus;
  public disableMinus;
  public platform;

  constructor(
    private modalCtrl: ModalController,
    public stateService: StateService
  ) { }

  ngOnInit() {
    this.platform = this.stateService.getPlatform();
    this.disableMinus = true;
  }

  plus() {
    if (this.size < 100) {
      this.size += 10;
      this.disablePlus = false;
      this.disableMinus = false;
    } else {
      this.disablePlus = true;
    }
  }

  minus() {
    if (this.size > 50) {
      this.size -= 10;
      this.disablePlus = false;
      this.disableMinus = false;
    } else {
      this.disableMinus = true;
    }
  }

  close() {
    this.modalCtrl.dismiss();
  }

}
