import { Component, OnInit } from '@angular/core';
import {map} from 'rxjs/operators';
import { NavController } from '@ionic/angular';
import { Unsubscriber } from '../../common/unsubscriber';
import { PatientService } from 'src/app/services/patient.service';
import { UserService } from 'src/app/services/user.service';
import { ToastService } from 'src/app/services/toast.service';

@Component({
  selector: 'app-caregivers',
  templateUrl: './caregivers.component.html',
  styleUrls: ['./caregivers.component.scss'],
})
export class CaregiversComponent extends Unsubscriber implements OnInit {
  public pageTitle = 'Caregiver Team';
  public careGivers$;

  constructor(
    private nav: NavController,
    private patientService: PatientService,
    public userService: UserService,
    private toast: ToastService,
  ) {
    super();
  }

  ngOnInit() {
    this.careGivers$ = this.patientService.getGuardians().pipe(
      map((data) => {
        return data;
      })
    );
  }

  addCaregiver() {
    this.nav.navigateForward([`/settings/add-caregiver`]);
  }
  resendInvite(user) {
    this.userService.sendResendInvite(user).subscribe((res) => {
      this.toast.presentToast('Resent invite to ' + user.full_name);
    });
  }
}
