import { Component, OnInit } from '@angular/core';
import { UserService } from 'src/app/services/user.service';
import { tap, map } from 'rxjs/operators';

@Component({
  selector: 'app-network',
  templateUrl: './network.component.html',
  styleUrls: ['./network.component.scss'],
})
export class NetworkComponent implements OnInit {
  public pageTitle = 'My Therapy Providers';
  public organizations$;
  constructor(
    public userService: UserService
  ) { }

  ngOnInit() {
    this.organizations$ = this.userService.getNetwork().pipe(
      map((data) => {
        return data.organizations;
      }),
      tap((val) => console.log(val))
    );
  }

}
