import { Component, OnInit } from '@angular/core';
import { UserService } from 'src/app/services/user.service';
import {tap, map, takeUntil} from 'rxjs/operators';
import { ToastService } from 'src/app/services/toast.service';

@Component({
  selector: 'app-organization',
  templateUrl: './organization.component.html',
  styleUrls: ['./organization.component.scss'],
})
export class OrganizationComponent implements OnInit {
  public pageTitle = 'Organization';
  public therapists$;
  public organization;
  constructor(
      public userService: UserService,
      private toast: ToastService,
  ) { }

  ngOnInit() {
    this.therapists$ = this.userService.getNetwork().pipe(
      tap((val) => console.log(val)),
      map((network) => {
        this.organization = network.organizations[0];
        return network.organizations[0].members;
      })
    );
  }

  resendInvite(user) {
    this.userService.sendResendInvite(user).subscribe((res) => {
      this.toast.presentToast('Resent invite to ' + user.full_name);
    });
  }
}
