import {IOSFilePicker} from '@ionic-native/file-picker/ngx';
import {FileChooser} from '@ionic-native/file-chooser/ngx';
import {FilePath} from '@ionic-native/file-path/ngx';

export interface FilePicker {
  pickFile();
}

export class IosFilePicker implements FilePicker {
  private _picker: IOSFilePicker;
  constructor(iosFilePicker: IOSFilePicker) {
    this._picker = iosFilePicker;
  }
  public pickFile() {
    return this._picker.pickFile();
  }
}

export class AndroidFilePicker implements FilePicker {
  private _picker: FileChooser;
  private _path: FilePath;
  constructor(fileChooser: FileChooser, filePath: FilePath) {
    this._picker = fileChooser;
    this._path = filePath;
  }
  public pickFile() {
    return this._picker.open()
      .then(uri => {
        if (uri.indexOf('content') === 0) {
          return this._path.resolveNativePath(uri);
        } else {
          return uri;
        }
      });
  }
}
