import { Injectable } from '@angular/core';
import { AuthService } from '../auth.service';
import {CanActivate, Router, ActivatedRouteSnapshot, RouterStateSnapshot, NavigationExtras} from '@angular/router';
import { NavController } from '@ionic/angular';

@Injectable({
  providedIn: 'root'
})
export class AuthGuardService implements CanActivate {
  path;
  route;
  constructor(
      private auth: AuthService,
      private nav: NavController,
      private router: Router) { }

  async canActivate(route: ActivatedRouteSnapshot, state: RouterStateSnapshot) {
    if (!this.auth.isAuthenticated()) {
      const navigationExtras: NavigationExtras = {
        queryParams: {
          returnUrl: state.url
        }
      };

      this.nav.navigateForward([`/auth`], navigationExtras);
      return false;
    } else {
      return true;
    }
  }
}
