import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { environment } from 'src/environments/environment';
import { Observable } from 'rxjs';
import { ITherapistWeekOverWeekEntry } from '../models/server/WeekOverWeekReport';

@Injectable({
  providedIn: 'root'
})
export class ReportsService {

  constructor(private http: HttpClient) { }

  getInsurance(organizationId: string, start: string, end: string) {
    return this.http.get<any>(`${environment.API_URL}/api/reports/insurance/${organizationId}/start/${start}/end/${end}`);
  }

  getTherapistWeekOverWeek(start: string, end: string): Observable<ITherapistWeekOverWeekEntry[]> {
    return this.http.get<ITherapistWeekOverWeekEntry[]>(`${environment.API_URL}/api/reports/therapistweekoverweek/start/${start}/end/${end}`);
  }

  getTherapistActivity(start: string, end: string) {
    return this.http.get<any>(`${environment.API_URL}/api/reports/therapistactivity/start/${start}/end/${end}`);
  }

  getGuardianActivity(start: string, end: string) {
    return this.http.get<any>(`${environment.API_URL}/api/reports/guardianactivity/start/${start}/end/${end}`);
  }
}
