import { Injectable } from '@angular/core';
import { Plugins } from '@capacitor/core';
const { Storage } = Plugins;

@Injectable({
  providedIn: 'root'
})
export class StorageService {

  constructor() { }

  async setObject(key: string, _value: any) {
    const value = JSON.stringify(_value);
    await Storage.set({ key, value });
  }

  async getObject(key: string) {
    const obj = await Storage.get({ key });
    return (JSON.parse(obj.value));
  }

  async deleteObject(key: string) {
    await Storage.remove({ key });
  }

  async keys() {
    return await Storage.keys();
  }

  async clear() {
    await Storage.clear();
  }
}
