import { Injectable } from '@angular/core';
import { ToastController } from '@ionic/angular';

@Injectable({
  providedIn: 'root'
})
export class ToastService {

  constructor(public toastController: ToastController) { }

  async presentToast(message: string, duration: number = 2000) {
    const toast = await this.toastController.create({
      message,
      duration,
      color: 'dark'
    });
    toast.present();
  }

  async presentToastWithClose(message, duration: number = 0) {
    const config: any = {
      message,
      color: 'dark',
      showCloseButton: true
    };

    if (duration > 0) {
      config.duration = duration;
    }

    const toast = await this.toastController.create(config);
    toast.present();
  }

  async presentToastTopWithClose(message, duration: number = 0) {
    const config: any = {
      message,
      color: 'light',
      showCloseButton: true,
      position: 'top'
    };

    if (duration > 0) {
      config.duration = duration;
    }

    const toast = await this.toastController.create(config);
    toast.present();
  }
}
