import {Injectable, EventEmitter, ElementRef, Renderer2, RendererFactory2, Inject} from '@angular/core';
import { HttpClientModule, HttpClient, HttpHeaders } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { Observer } from 'rxjs';
import { connect, createLocalTracks, createLocalVideoTrack, LocalVideoTrack  } from 'twilio-video';
import { BehaviorSubject } from 'rxjs';
import {AudioService} from './audio.service';
import {PatientService} from './patient.service';
import {UserService} from './user.service';
import {NgxSpinnerService} from 'ngx-spinner';
import { ToastService } from 'src/app/services/toast.service';
import {User} from '../models/client/User';
import {$} from 'jquery';
import {assertNumber} from '@angular/core/src/render3/assert';

@Injectable()
export class TwilioService {
    private globalInstance: () => void;
    private renderer: Renderer2;

  constructor(
      private http: HttpClient,
      private audio: AudioService,
      private patientService: PatientService,
      private userService: UserService,
      private toastService: ToastService,
      // private socketService: SocketsService,
      private spinner: NgxSpinnerService,
      rendererFactory: RendererFactory2,
      // @Inject(Document) private document,

  ) {
    this.isMuted = false;
    this.videoMuted = false;
    this.renderer = rendererFactory.createRenderer(null, null);

  }

  remoteVideo1: ElementRef;
  remoteVideo2: ElementRef;
  remoteVideo3: ElementRef;
  remoteVideo4: ElementRef;
  remoteVideo5: ElementRef;
  remoteVideo6: ElementRef;
  remoteVideo7: ElementRef;
  remoteVideo8: ElementRef;
  remoteVideo9: ElementRef;
  remoteVideo10: ElementRef;
  leaveRoom: ElementRef;
  roomDiv: ElementRef;
    mainParticipant1: ElementRef;
    mainParticipant2: ElementRef;
    mainParticipant3: ElementRef;
    mainParticipant4: ElementRef;
    mainParticipant5: ElementRef;
    mainParticipant6: ElementRef;
    mainParticipant7: ElementRef;
    mainParticipant8: ElementRef;
    mainParticipant9: ElementRef;
    mainParticipant10: ElementRef;
    participant1Div: ElementRef;
    participant2Div: ElementRef;
    participant3Div: ElementRef;
    participant4Div: ElementRef;
    participant5Div: ElementRef;
    participant6Div: ElementRef;
    participant7Div: ElementRef;
    participant8Div: ElementRef;
    participant9Div: ElementRef;
    participant10Div: ElementRef;
    activeParticipant1Video: ElementRef;
    activeParticipant2Video: ElementRef;
    activeParticipant3Video: ElementRef;
    activeParticipant4Video: ElementRef;
    activeParticipant5Video: ElementRef;
    activeParticipant6Video: ElementRef;
    activeParticipant7Video: ElementRef;
    activeParticipant8Video: ElementRef;
    activeParticipant9Video: ElementRef;
    activeParticipant10Video: ElementRef;
  // remoteVideo3: ElementRef;
  localVideo: ElementRef;
  remoteVideoSmall: ElementRef;
  previewing: boolean;
  msgSubject = new BehaviorSubject('');
  roomObj: any;
  localVideoTrack: any;
  remoteVideoTrack: any;
  isMuted: boolean;
  videoMuted: boolean;
  currentSpeaker: any; // Participant
  private BreakException: any;
  private screensharetrack: any;
  private leave = this.leaveRoom;
  private room = this.roomDiv;
  private mainParticipant1Div = this.mainParticipant1;
  /*private mainParticipant1 = this.mainParticipant1;
  private mainParticipant2 = this.mainParticipant2;
  private mainParticipant3 = this.mainParticipant3;
  private mainParticipant4 = this.mainParticipant4;
  private mainParticipant5 = this.mainParticipant5;
  private mainParticipant6 = this.mainParticipant6;
  private mainParticipant7 = this.mainParticipant7;
  private mainParticipant8 = this.mainParticipant8;
  private mainParticipant9 = this.mainParticipant9;
  private mainParticipant10 = this.mainParticipant10;
  private activeParticipant = this.mainParticipant;
  private activeVideo = this.activeParticipantVideo;
  private participantDiv = this.participantsDiv;*/

    // The current active Participant in the Room.
  private track: any;
    // Whether the user has selected the active Participant by clicking on
    // one of the video thumbnails.
  private isActiveParticipantPinned = false;

  setActiveParticipant(participant) {

    if (this.mainParticipant1) {
      // this.activeParticipant.nativeElement = $(`div#${this.activeParticipant.sid}`, this.participants);
      this.mainParticipant1.nativeElement.removeClass('active');
      this.mainParticipant1.nativeElement.removeClass('pinned');

      // Detach any existing VideoTrack of the active Participant.
     /* const { track: activeTrack }: unknown = Array.from(this.activeParticipant.videoTracks.values())[0] || {};
      if (activeTrack) {
        activeTrack.detach(this.activeVideo.get(0));
        this.activeVideo.css('opacity', '0');
      }*/
      this.detachParticipantTracks(participant);
    }

    // Set the new active Participant.
    this.mainParticipant1 = participant;
    const { identity, sid } = participant;
    const $participant = $(`div#${sid}`, this.participant1Div);

    $participant.addClass('active');
    if (this.isActiveParticipantPinned) {
      $participant.addClass('pinned');
    }

    // Attach the new active Participant's video.
    let track;
    track = Array.from(participant.videoTracks.values())[0] || {};
    if (track) {
          track.attach(this.activeParticipant1Video.nativeElement.get(0));
          this.activeParticipant1Video.nativeElement.css('opacity', '');
      }


    // Set the new active Participant's identity
    this.mainParticipant1.nativeElement.attr('data-identity', identity);
  }


getToken(username): Observable < any > {
    return this.http.post('url', { uid: username });
  }

  /*startRoom(accessToken: string, options): void {
    createLocalTracks({
      audio: true,
      video: { width: 640 }
    }).then(localTracks => {
      localTracks.forEach(track => {
        console.log('track.name');
        console.log(track.name);
        this.localVideo.nativeElement.appendChild(track.attach());
      });
      return connect(accessToken, options);
    }).then(room => {
      console.log(`Connected to Room: ${room.name}`);
    });
  }*/

connectToRoom(accessToken: string, options): void {

    connect(accessToken, options).then(room => {

      this.roomObj = room;

      // Get the camera track for your preview.
      /*room.localParticipant.tracks.forEach(tracks => {
        const innerTracks = Array.from(room.localParticipant.innerTracks.values());
        innerTracks.forEach((innerTrack: any) => {
          this.localVideo.nativeElement.appendChild(innerTrack.attach());
        });
      });
*/

      console.log('room from top of connectToRoom');
      console.log(room);

      // this.previewing = true;

      // if (!this.previewing && options.video) {
      //   console.log('inside start local video');
      this.startLocalVideo(room);
      //   this.previewing = true;
        // return;
     //  }

      room.participants.forEach(participant => {
       /* try {
          if (participant.identity === room.localParticipant.tracks.identity) { throw this.BreakException; }
          const previewContainer = document.getElementById('remote');
          this.attachParticipantTracks(participant, previewContainer);
        } catch (e) {
          if (e !== this.BreakException) { throw e; }
        }*/
        this.msgSubject.next('<span class="oval"></span>\'' + participant.identity + '\' already in the room');
        // this.toastService.presentToast('<span class="oval"></span>\'' + participant.identity + '\' already in the room');
        // console.log('Already in Room: \'' + participant.identity + '\'');
        const nextDiv = this.findNextEmptyDiv();
        let previewContainer: HTMLElement;
        previewContainer = document.getElementById(nextDiv);
        this.attachParticipantTracks(participant, previewContainer);
        previewContainer = document.getElementById('remoteVideoSmall');
        this.attachParticipantTracks(participant, previewContainer);
      });

      room.on('participantDisconnected', (participant) => {
        /*if (participant.tracks) {
          participant.tracks.forEach(track => {
            track.stop();
          });
        }*/


       this.localVideoTrack.stop();


          // videoElem.srcObject = null;

       this.msgSubject.next('<span class="oval"></span>\'' + participant.identity + '\' left the room');
        // this.toastService.presentToast('<span class="oval"></span>\'' + participant.identity + '\' left the room');
        // console.log('Participant \'' + participant.identity + '\' left the room');

        // participant.tracks.forEach(this.trackRemoved);
        // document.getElementById(participant.sid).remove();
       /* console.log('room.localParticipant');
        console.log(room.localParticipant);
        room.localParticipant.tracks.forEach(track => {
          track.track.stop();
        });
*/
       this.roomObj.localParticipant.tracks.forEach(publication => {
          // publication.track.stop();
          // const attachedElements = publication.track.detach();
          // console.log('unsubscribed from: ' + publication.track);
          // attachedElements.forEach(element => element.remove());
        });

       this.detachParticipantTracks(participant);
      });

      room.on('participantConnected',  (participant) => {
        /*this.userService.getUser(participant.identity).subscribe(
            (res) => {
              const user_name = this.userService.user.first_name + ' ' + this.userService.user.last_name;
              this.msgSubject.next('Participant \'' + user_name + '\' joined the room');
              // console.log('Participant \'' + user_name + '\' joined the room');
            });*/


        // Set up the Participant's media container.
        this.setupParticipantContainer(participant, room);

        // Handle the TrackPublications already published by the Participant.
        participant.tracks.forEach(publication => {
          this.trackPublished(publication, participant);
        });

        // Handle theTrackPublications that will be published by the Participant later.
        participant.on('trackPublished', publication => {
          this.trackPublished(publication, participant);
        });

        console.log('participant ');
        console.log(participant);
        this.msgSubject.next('<span class="oval"></span>\'' + participant.identity + '\' joined the room');
        // this.toastService.presentToast('<span class="oval"></span>\'' + participant.identity + '\' joined the room');
        /*participant.tracks.forEach(track => {
           console.log('track.name inside participantConnected');
           console.log(track.name);
           this.remoteVideo1.nativeElement.appendChild(track.attach());
           this.remoteVideoSmall.nativeElement.appendChild(track.attach());
           this.remoteVideoTrack = track;
           console.log('track inside participantConnected');
           console.log(track);
           console.log('inside first participant group');
           console.log(track);
         });*/

        // this.remoteVideoSmall.nativeElement.appendChild(track.attach());

        this.audio.pause('play');
        this.spinner.hide();

      });

      // When a Participant adds a Track, attach it to the DOM.
      room.on('trackAdded', (track, participant) => {
        console.log('track.name ' + track.name);
        console.log('track = ' + track);
        console.log(participant.identity + ' added track: ' + track.kind  + 'named ' + track.name);
        // const container = document.getElementById('remote');
        const nextDiv = this.findNextEmptyDiv();
        let container: HTMLElement;
        container = document.getElementById(nextDiv);
        this.attachTracks([track], [participant], container);
        console.log('track.name = ' + track.name);
        this.remoteVideoSmall.nativeElement.appendChild(track.attach());
      });

      // When a Participant removes a Track, detach it from the DOM.
      room.on('trackRemoved', (track, participant) => {
        // track.mediaStreamTrack.stop();
         this.stopCamera(room);
         console.log('room.participants.size = ' + room.participants.size);
         // this.stopCamera(room);

        // console.log('this.twilioService.roomObj.localParticipant.videoTracks');
        // const videoTracks = room.localParticipant.videoTracks.values()[0].med;
        // console.log(room.localParticipant.videoTracks);
        // videoTracks.stop();

        /*room.localParticipant.videoTracks.forEach(function(
            videoTrack
        ) {
          console.log("turning off camera");
          videoTrack.stop();
        });*/


        // track.mediaStreamTrack.stop();

        // this.detachParticipantTracks(room.localParticipant);

        // room.participants.forEach(function(trackstoStop) {
       //    this.detachParticipantTracks(trackstoStop);
        // });

         // console.log(track);
         console.log(participant.identity + ' removed track: ' + track.kind);
         room.localParticipant.tracks.forEach(tracks => tracks.stop());

        /*room.localParticipant.tracks.forEach(publication => {
          console.log('publication');
          console.log(publication);
          publication.stop();
          // room.localParticipant.tracks.forEach(track => track.stop());
          const videoTrack = room.localParticipant.videoTracks.values().next().value;
          const audioTrack = room.localParticipant.audioTracks.values().next().value;
          videoTrack.stop();
          const tracktoRemove = [room.localParticipant.videoTracks.values()][0];
          tracktoRemove.stop();
          room.localParticipant.unpublishTrack(videoTrack);
          room.localParticipant.unpublishTrack(audioTrack);
          // publication.track.stop();
        });
        room.disconnect();*/
        // tracks.forEach(trackage => trackage.track.stop());
        /// const cameraTrack = this.roomObj.localParticipant.videoTracks.values()[0].track;
        // this.roomObj.localParticipant.videoTracks[0].stop();
        // this.roomObj.localParticipant.audioTracks[0].stop();
        // this.roomObj.localParticipant.tracks.forEach(track => console.log(track);track.stop());
         this.detachTracks([track]);
      });

      room.once('disconnected',  r => {
        console.log('inside disconnect in twilio service');
        // this.msgSubject.next('You left the Room:' + r.name);


        // this.msgSubject.next('<span class="oval"></span>You left the Room:' + r.name);
        if (this.localVideoTrack) {
          this.localVideoTrack.stop();
          this.localVideoTrack = null;
        }
        r.localParticipant.tracks.forEach(track => {
          this.localVideo.nativeElement.remove();
          const attachedElements = track.detach();
          attachedElements.forEach(element => element.remove());
        });
        this.localVideoTrack = null;
      });
    });
  }

    setCurrentActiveParticipant(room) {
        const { dominantSpeaker, localParticipant } = room;
        this.setActiveParticipant(dominantSpeaker || localParticipant);
    }

    findNextEmptyDiv() {
        // find next empty div without video tag inside div
        // const numberCheck  = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
        const numberCheck  = [1, 2, 3, 4];
        let nextEmptyDiv = '';

        let firstVideo = document.getElementById('remote1').getElementsByTagName('video')[0];
        console.log('firstVideo');
        console.log(firstVideo);
        if (!firstVideo) {
            return 'remote1';
        }

        firstVideo = document.getElementById('remote2').getElementsByTagName('video')[0];
        console.log('firstVideo');
        console.log(firstVideo);
        if (!firstVideo) {
            return 'remote2';
        }

        firstVideo = document.getElementById('remote3').getElementsByTagName('video')[0];
        console.log('firstVideo');
        console.log(firstVideo);
        if (!firstVideo) {
            return 'remote3';
        }

        firstVideo = document.getElementById('remote4').getElementsByTagName('video')[0];
        console.log('firstVideo');
        console.log(firstVideo);
        if (!firstVideo) {
            return 'remote4';
        }

        firstVideo = document.getElementById('remote5').getElementsByTagName('video')[0];
        console.log('firstVideo');
        console.log(firstVideo);
        if (!firstVideo) {
            return 'remote5';
        }

        firstVideo = document.getElementById('remote6').getElementsByTagName('video')[0];
        console.log('firstVideo');
        console.log(firstVideo);
        if (!firstVideo) {
            return 'remote6';
        }

        firstVideo = document.getElementById('remote7').getElementsByTagName('video')[0];
        console.log('firstVideo');
        console.log(firstVideo);
        if (!firstVideo) {
            return 'remote7';
        }

        firstVideo = document.getElementById('remote8').getElementsByTagName('video')[0];
        console.log('firstVideo');
        console.log(firstVideo);
        if (!firstVideo) {
            return 'remote8';
        }

        firstVideo = document.getElementById('remote9').getElementsByTagName('video')[0];
        console.log('firstVideo');
        console.log(firstVideo);
        if (!firstVideo) {
            return 'remote9';
        }

        firstVideo = document.getElementById('remote10').getElementsByTagName('video')[0];
        console.log('firstVideo');
        console.log(firstVideo);
        if (!firstVideo) {
            return 'remote10';
        }

        // tslint:disable-next-line:prefer-for-of
        for (let i = 1; i < numberCheck.length; i++) {
            console.log(i);

            console.log('findNextEmptyDiv');
            console.log('remote' + i);
            const div = document.getElementById('remote' + i);
            if (!div.hasChildNodes()) {
                if ('remote' + i === 'remote1') {
                    nextEmptyDiv = 'remote1';
                    return 'remote1';
                    break;
                }
                console.log(div.childNodes.length);
                nextEmptyDiv = 'remote' + i;
                return 'remote' + i;
                break;
            }
        }
        return '';
    }

setupParticipantContainer(participant, room) {
    const { identity, sid } = participant;
    // Add a container for the Participant's media.
    // container = '<div class="participant" data-identity="${identity}" id="${sid}" <audio autoplay ${participant === room.localParticipant ? \'muted\' : \'\'} ' +
    // 'style="opacity: 0"></audio><video autoplay muted playsinline style="opacity: 0"></video></div>';
   /* let container: HTMLInputElement;
    container = document.createElement('div');
    container.classList.add('participant');
    container.setAttribute('data-identity', identity);
    container.setAttribute('id', sid);*/

    // Toggle the pinning of the active Participant's video.

   // this.mainParticipant1.nativeElement.addEventListener('click', this.onClickmainParticipant1.bind(this, participant, room));
    /*this.globalInstance = this.renderer.listen(this.mainParticipant1.nativeElement, 'click', () => {
        if (this.mainParticipant1 === participant && this.isActiveParticipantPinned) {
            // Unpin the RemoteParticipant and update the current active Participant.
            this.setVideoPriority(participant, null);
            this.isActiveParticipantPinned = false;
            this.setCurrentActiveParticipant(room);
        } else {
            // Pin the RemoteParticipant as the active Participant.
            if (this.isActiveParticipantPinned) {
                this.setVideoPriority(this.mainParticipant1, null);
            }
            this.setVideoPriority(participant, 'high');
            this.isActiveParticipantPinned = true;
            this.setActiveParticipant(participant);
        }
    });*/

    // Add the Participant's container to the DOM.
    // this.participant1Div.nativeElement.appendChild(container);
  }


    onClickmainParticipant1(event, participant, room) {

    }

    setVideoPriority(participant, priority) {
        participant.videoTracks.forEach(publication => {
            const track = publication.track;
            if (track && track.setPriority) {
                track.setPriority(priority);
            }
        });
    }


    trackPublished(publication, participant) {
        // If the TrackPublication is already subscribed to, then attach the Track to the DOM.
        if (publication.track) {
            this.attachTrack(publication.track, participant);
        }
    }

    attachTrack(track, participant) {
        // Attach the Participant's Track to the thumbnail.
        const $media = $(`div#${participant.sid} > ${track.kind}`, this.participant1Div);
        $media.css('opacity', '');
        track.attach($media.get(0));

        // If the attached Track is a VideoTrack that is published by the active
        // Participant, then attach it to the main video as well.
        if (track.kind === 'video' && participant === this.mainParticipant1) {
            track.attach(this.activeParticipant1Video.nativeElement.get(0));
            this.activeParticipant1Video.nativeElement.css('opacity', '');
        }
    }

    trackAdded(div, track) {
    div.appendChild(track.attach());
    const video = div.getElementsByTagName('video')[0];
    if (video) {
      video.setAttribute('style', 'max-width:300px;');
    }
  }

    trackRemoved(track) {
    track.detach().forEach( element => { element.remove(); });
  }

    checkRoomSize() {
    return this.roomObj.participants.size;
  }

    async stopCamera(room) {
    /*const stream = await navigator.mediaDevices.getUserMedia({video: true});
    await new Promise(resolve => setTimeout(resolve, 2000));
    stream.getTracks()[0].stop();*/
    const tracks = Array.from(room.localParticipant.tracks.values());
    tracks.forEach((track: any) => {
      track.detach().forEach(detachedElement => {
        detachedElement.stop();
      });
    });
  }



    attachParticipantTracks(participant, container): void {
    const tracks = Array.from(participant.tracks.values());
    // this.attachTracks([tracks], participant);
    this.attachTracks(tracks, participant, container);
    if (container === 'remoteVideoSmall') {
      const previewContainer = document.getElementById('remoteVideoSmall');
      this.attachTracks(tracks, participant, previewContainer);
    }
  }


attachTracks(tracks, participant, container) {
    // console.log(tracks);
    // console.log(participant);

    console.log('container');
    console.log(container);

    tracks.forEach(track => {
      // console.log('track');
      // console.log(track);
      // console.log('participant');
      // console.log(participant);
      container.appendChild(track.attach());
      // const name = document.createElement('p');
      // name.classList.add('video-name-overlay');
      // name.append(document.createTextNode('Remote user name'));
      // this.remoteVideo1.nativeElement.append(name);
    });
  }

swapVideoForScreenShare(participant, track) {
    // attach the new speaker's tracks to remotevideo2
    // this.detachParticipantTracks(participant); // First detach the tracks
    // const previewContainer = document.getElementById('remote2');
    // this.remoteVideo2.nativeElement.appendChild(track.attach());
    // console.log('this.localVideoTrack');
    // console.log(this.localVideoTrack);
    // this.attachTracks(this.localVideoTrack, participant, previewContainer);
  }

attachScreenShareTrack(track, participant) {
    this.roomObj.localParticipant.publishTrack(track);
    console.log('inside screen share');
    this.screensharetrack = track;

    this.msgSubject.next('<div><img src="assets/screen_share-24px.svg" class="sharingMessage">\'' + participant.identity + '\' began sharing</div>');
    // this.toastService.presentToast('<img src="assets/screen_share-24px.svg" class="sharingMessage">\'' + participant.identity + '\' began sharing</img>');

    // this.remoteVideo1.nativeElement.appendChild(track.attach());
    track.on('stopped', () => {
        console.log('this.roomObj.localParticipant.publishedTracks in stopped screenshare');
        console.log('stop screenshare track');
        console.log(track);
        // Access the already published LocalTracks.
        this.roomObj.localParticipant.tracks.forEach(publication => {
              console.log(`Published LocalTrack: ${publication}`);
            }
        );
        // participant.unpublishTrack(this.screensharetrack);
        console.log('this.remoteVideoTrack inside stop attachscreensharetrack');
        console.log(this.remoteVideoTrack);
        console.log('this.localVideoTrack inside stop attachscreensharetrack');
        console.log(this.localVideoTrack);
        const token = document.getElementById('join-incoming-call-notification').dataset.token;
        const roomName = document.getElementById('join-incoming-call-notification').dataset.roomname;
        this.roomObj.localParticipant.publishTrack(this.localVideoTrack);
        // this.roomObj.localParticipant.videoTracks.forEach(localtracks => {
        //   localtracks.enable();
        // });
        document.getElementById('remoteVideoSmall').style.display = 'none';
        this.remoteVideoSmall.nativeElement.appendChild(track.attach());
        document.getElementById('remoteVideoSmall').style.display = 'none';
        this.msgSubject.next('<div><img src="assets/screen_share-24px.svg" class="sharingMessage">\'' + participant.identity + '\' stopped sharing</div>');
        /*while (this.remoteVideoSmall.nativeElement.firstChild) {
          this.remoteVideoSmall.nativeElement.removeChild(this.remoteVideoSmall.nativeElement.lastChild);
        }*/
        // this.toastService.presentToast('<img src="assets/screen_share-24px.svg" class="sharingMessage">\'' + participant.identity + '\' stopped sharing</div>');
        // this.socketService.detachScreenShareTrack(participant.identity);
        // this.roomObj.localParticipant.publishTrack(this.remoteVideoTrack);
      });
  }

switchSizes() {
    // console.log('this.remoteVideo1.nativeElement.childNodes');
    // console.log(this.remoteVideo1.nativeElement.childNodes);
    // console.log('this.localVideo.nativeElement.childNodes');
    // console.log(this.localVideo.nativeElement.childNodes);
    const remoteVideoContent0 = this.remoteVideo1.nativeElement.childNodes[0];
    const remoteVideoContent1 = this.remoteVideo1.nativeElement.childNodes[1];
    // const remoteVideoContent2 = this.remoteVideo1.nativeElement.childNodes[2];
    const localVideoContent0 = this.localVideo.nativeElement.childNodes[0];
    const localVideoContent1 = this.localVideo.nativeElement.childNodes[1];
    // const localVideoContent2 = this.localVideo.nativeElement.childNodes[2];

    // console.log(localVideoContent);
    // console.log(remoteVideoContent);

    /*while (this.remoteVideo1.nativeElement.firstChild) {
      this.remoteVideo1.nativeElement.removeChild(this.remoteVideo1.nativeElement.lastChild);
    }

    while (this.localVideo.nativeElement.firstChild) {
      this.localVideo.nativeElement.removeChild(this.localVideo.nativeElement.lastChild);
    }*/

    // console.log('localVideoContent0');
    // console.log(localVideoContent0);
    // console.log('localVideoContent1');
    // console.log(localVideoContent1);
    // console.log('localVideoContent2');
    // console.log(localVideoContent2);

    // console.log('remoteVideoContent0');
    // console.log(remoteVideoContent0);
    // console.log('remoteVideoContent1');
    // console.log(remoteVideoContent1);
    // console.log('remoteVideoContent2');
    // console.log(remoteVideoContent2);

    this.remoteVideo1.nativeElement.appendChild(localVideoContent0);
    this.remoteVideo1.nativeElement.appendChild(localVideoContent1);
    // this.remoteVideo1.nativeElement.appendChild(localVideoContent2);
    this.localVideo.nativeElement.appendChild(remoteVideoContent0);
    this.localVideo.nativeElement.appendChild(remoteVideoContent1);
    // this.localVideo.nativeElement.appendChild(remoteVideoContent2);

  }


startLocalVideo(room): void {
    createLocalVideoTrack().then(track => {
       console.log('track');
       console.log(track);

      // console.log(room);
       this.localVideoTrack = track;
       this.localVideo.nativeElement.appendChild(track.attach());
      // const name = document.createElement('p');
      // name.classList.add('video-name-overlay');
      // name.append(document.createTextNode('Your name'));
      // this.localVideo.nativeElement.append(name);
      // console.log(track.attach());
    });
  }

toggleAudio(): void {
    if (this.isMuted === false) {
      this.isMuted = true;
      this.roomObj.localParticipant.audioTracks.forEach(audioTrack => {
        audioTrack.disable();
      });
    } else {
      this.isMuted = false;
      this.roomObj.localParticipant.audioTracks.forEach(audioTrack => {
        audioTrack.enable();
      });
    }
  }

toggleVideo(): void {
    if (this.videoMuted === false ) {
      this.videoMuted = true;
      this.roomObj.localParticipant.videoTracks.forEach(videoTrack => {
        videoTrack.disable();
      });
    } else {
      this.videoMuted = false;
      this.roomObj.localParticipant.videoTracks.forEach(videoTrack => {
        videoTrack.enable();
      });
    }
  }

toggleRemoteVideo(picture) {
    // get user picture based on user id
    let hasAvatar = false;

    const children = this.remoteVideo1.nativeElement.childNodes;
    children.forEach(item => {
      if (item.id === 'remoteAvatar') {
        hasAvatar = true;
        // remove avatar if it exists
        const avatarImage = document.getElementById('remoteAvatar');
        this.remoteVideo1.nativeElement.removeChild(avatarImage);
      }
    });

    if (hasAvatar === false) {
      const avatar = document.createElement('img');
      avatar.classList.add('display-on-top');
      avatar.setAttribute('id', 'remoteAvatar');
      avatar.src = picture;
      this.remoteVideo1.nativeElement.append(avatar);
      children.forEach(item => {
        console.log('item.tagName inside hasAvatar');
        console.log(item.tagName);
        if (item.tagName === 'VIDEO') {
          // item.setAttribute('display', 'none');
          item.classList.add('display-none');
        }
      });
    } else {
      children.forEach(item => {
        if (item.tagName === 'VIDEO') {
          item.classList.remove('display-none');
        }
      });
    }



    // const img = picture;
    // console.log('img inside toggleRemoteVideo');
    // console.log(img);

    // remoteDiv2.innerHTML = '<img src="' + img + '">';

   /* if (remoteDiv.style.display === 'none') {
      remoteDiv.style.display = 'inline';
    } else {
      remoteDiv.style.display = 'none';
    }

    if (remoteDiv2.style.display === 'none') {
      remoteDiv2.style.display = 'inline';
    } else {
      remoteDiv2.style.display = 'none';
    }*/
  }


localPreview(): void {
    /*createLocalVideoTrack().then(track => {
      this.localVideo.nativeElement.appendChild(track.attach());
    });*/
  }

detachParticipantTracks(participant) {
    const tracks = Array.from(participant.tracks.values());
    this.detachTracks(tracks);
  }

detachTracks(tracks): void {
    tracks.forEach(track => {
      track.mediaStreamTrack.stop();
      // track.track.stop();
      track.detach().forEach(detachedElement => {
        detachedElement.remove();
      });
    });
  }

}
